//
#include <linux/device.h>
#include <linux/kdev_t.h>
#include <linux/types.h>
#include <linux/cdev.h>
#include <linux/init.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/fs.h>
#include <asm/uaccess.h>

//#include <linux/kallsyms.h>

MODULE_LICENSE("GPL");
MODULE_AUTHOR("Igor D: 19.08.2021");
MODULE_DESCRIPTION("mod0 testing.");
MODULE_VERSION("1.01");

#define MSG_BUFFER_LEN 	32

static char instr[MSG_BUFFER_LEN];
EXPORT_SYMBOL(instr);
static char outstr[MSG_BUFFER_LEN];
EXPORT_SYMBOL(outstr);
static size_t mlen;

static int mod0_strreverse(char * inbuf, size_t len) {
	int cnt1 = 0;
	int cnt2 = 0;
	char sym;
	memset(instr, 0, MSG_BUFFER_LEN);
	//
	if(!(len < MSG_BUFFER_LEN))
		return -EINVAL;
	while(cnt1 < len) {
		sym = (*(char*)(inbuf + cnt1));
		printk(KERN_INFO "From mod1: SI:%c (HEX=%02X)\n", sym, sym);
		if(sym >= 0x20)
			instr[cnt1] = sym;
		else
			break;
		cnt1++;
	}
	//reverse
	cnt2 = 0;
	while(cnt2 < cnt1) {
		outstr[cnt2] = instr[cnt1 - cnt2 - 1];
		printk(KERN_INFO "mod0: outstr sim(num=%i):%c\n", cnt2, outstr[cnt2]);
		cnt2++;
	}
	outstr[cnt2] = 0x0a;
	cnt2++;
	mlen = cnt2;
	return cnt2;
}

EXPORT_SYMBOL(mod0_strreverse);

static size_t mod0_outstr(char * buff) {
	int cnt = 0;
	while(cnt < mlen) {
		(*(char*)(buff + cnt)) = outstr[cnt];
		cnt++;
	}
	return mlen;
}

EXPORT_SYMBOL(mod0_outstr);


static int __init mod0_init(void) {

		printk(KERN_INFO "mod0 module loaded\n");
		return 0;
}

static void __exit mod0_exit(void) {
	printk(KERN_INFO "mod0 unloaded!\n");
}

/* Register module functions */
module_init(mod0_init);
module_exit(mod0_exit);
